from typing import List, Dict

from peek_core_search._private.PluginNames import searchTuplePrefix
from peek_core_search.tuples.ImportSearchObjectRouteTuple import \
    ImportSearchObjectRouteTuple
from vortex.Tuple import Tuple, addTupleType, TupleField


@addTupleType
class ImportSearchObjectTuple(Tuple):
    """ Import Search Object

    This tuple is used by other plugins to load objects into the search index.

    """
    __tupleType__ = searchTuplePrefix + 'ImportSearchObjectTuple'

    #:  The unique key for this object
    key: str = TupleField()

    #:  The type of this object
    objectType: str = TupleField()

    #:  The details to index.
    # Do not include "key", it will be indexed anyway.
    # The key of the property will match of create a new "SearchProperty"
    properties: Dict[str, str] = TupleField({})

    #:  The color
    routes: List[ImportSearchObjectRouteTuple] = TupleField([])
